/**
* loadPoints
*
* Blockpraktikum Informationsvisualisierung mit Processing
* Daniel Buschek, Johannes Preis
* 28. 2. 2012
*/

//Arrays zum Speichern der zu lesenden Informationen:
int[] xWerte; //Hier werden die x-Koordinaten der Punkte gespeichert.
int[] yWerte; //Hier werden die y-Koordinaten der Punkte gespeichert.

int maxX = 0;
int maxY = 0;

int rand = 20;

int shapeMode = 0;
float minGroesse = 20;
float maxGroesse = 100;
float groesse = 20;

void setup() {

  size(640, 480);
  smooth();
  rectMode(CENTER);

  //Datei einlesen:
  String[] zeilen = loadStrings("punkte.txt");

  //Anzahl der Punkte bestimmen:
  int anzahlEintraege = zeilen.length;

  //Arrays zum Speichern der zu lesenden Informationen anlegen:
  xWerte = new int[anzahlEintraege];
  yWerte = new int[anzahlEintraege];


  //Alle Zeilen der Datei durchgehen:
  for (int i = 0; i < zeilen.length; i++) { 

    //Aktuelle Zeile teilen (an allen ";" ):
    String[] spalten = splitTokens(zeilen[i], ";");

    //Werte lesen:
    int xWert = int(spalten[0]);
    int yWert = int(spalten[1]);

    //Array füllen:
    xWerte[i] = xWert;
    yWerte[i] = yWert;

    //Maximalwerte aktualisieren, falls nötig:
    if (xWert > maxX) 
      maxX = xWert;
    if (yWert > maxY)
      maxY = yWert;
  }
}


void draw() {

  background(255);
  fill(100, 140, 200);

  //Alle Punkte durchgehen und darstellen:
  for (int i = 0; i < xWerte.length; i++) {
   
    if (shapeMode == 0) { // 0: circle
       ellipse(rand + xWerte[i]/(float)maxX * (width- 2*rand), 
    height - rand - yWerte[i]/(float)maxY * (height - 2*rand), groesse, groesse);
    } 
    else if (shapeMode == 1) { // 1: rectangle
       rect(rand + xWerte[i]/(float)maxX * (width- 2*rand), 
    height - rand - yWerte[i]/(float)maxY * (height - 2*rand), groesse, groesse);
    }
  }
}

// Klick mit linker Maustaste: Ändert die Darstellungsform
void mouseClicked() {
  if (mouseButton == LEFT) {
    shapeMode = (shapeMode + 1) % 2;
  }
}

// Bewegen der Maus bei gedrückter rechtr Maustaste: Änderung der Größe der Formen
void mouseDragged() {
 if (mouseButton == RIGHT) {
  groesse = map(mouseY, 0, height, minGroesse, maxGroesse);
 } 
}

